package org.jboss.security;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.MessageDigest;

public final class Base64Encoder {

   private static final int BUFFER_SIZE = 1024;
   private static final byte[] encoding = new byte[]{(byte)65, (byte)66, (byte)67, (byte)68, (byte)69, (byte)70, (byte)71, (byte)72, (byte)73, (byte)74, (byte)75, (byte)76, (byte)77, (byte)78, (byte)79, (byte)80, (byte)81, (byte)82, (byte)83, (byte)84, (byte)85, (byte)86, (byte)87, (byte)88, (byte)89, (byte)90, (byte)97, (byte)98, (byte)99, (byte)100, (byte)101, (byte)102, (byte)103, (byte)104, (byte)105, (byte)106, (byte)107, (byte)108, (byte)109, (byte)110, (byte)111, (byte)112, (byte)113, (byte)114, (byte)115, (byte)116, (byte)117, (byte)118, (byte)119, (byte)120, (byte)121, (byte)122, (byte)48, (byte)49, (byte)50, (byte)51, (byte)52, (byte)53, (byte)54, (byte)55, (byte)56, (byte)57, (byte)43, (byte)47, (byte)61};


   public static void encode(InputStream in, OutputStream out) throws IOException {
      process(in, out);
   }

   public static void encode(byte[] input, OutputStream out) throws IOException {
      ByteArrayInputStream in = new ByteArrayInputStream(input);
      process(in, out);
   }

   public static String encode(String input) throws IOException {
      byte[] bytes = input.getBytes("ISO-8859-1");
      return encode((byte[])bytes);
   }

   public static String encode(byte[] bytes) throws IOException {
      ByteArrayInputStream in = new ByteArrayInputStream(bytes);
      ByteArrayOutputStream out = new ByteArrayOutputStream();
      process(in, out);
      return out.toString("ISO-8859-1");
   }

   public static void main(String[] args) throws Exception {
      if(args.length == 1) {
         System.out.println("[" + encode((String)args[0]) + "]");
      } else if(args.length == 2) {
         byte[] hash = MessageDigest.getInstance(args[1]).digest(args[0].getBytes());
         System.out.println("[" + encode((byte[])hash) + "]");
      } else {
         System.out.println("Usage: Base64Encoder <string> <optional hash algorithm>");
      }

   }

   private static int get1(byte[] buf, int off) {
      return (buf[off] & 252) >> 2;
   }

   private static int get2(byte[] buf, int off) {
      return (buf[off] & 3) << 4 | (buf[off + 1] & 240) >>> 4;
   }

   private static int get3(byte[] buf, int off) {
      return (buf[off + 1] & 15) << 2 | (buf[off + 2] & 192) >>> 6;
   }

   private static int get4(byte[] buf, int off) {
      return buf[off + 2] & 63;
   }

   private static void process(InputStream in, OutputStream out) throws IOException {
      byte[] buffer = new byte[1024];
      boolean got = true;
      int off = 0;
      int count = 0;

      int var10;
      while((var10 = in.read(buffer, off, 1024 - off)) > 0) {
         if(var10 >= 3) {
            var10 += off;

            int i;
            for(off = 0; off + 3 <= var10; off += 3) {
               i = get1(buffer, off);
               int c2 = get2(buffer, off);
               int c3 = get3(buffer, off);
               int c4 = get4(buffer, off);
               switch(count) {
               case 73:
                  out.write(encoding[i]);
                  out.write(encoding[c2]);
                  out.write(encoding[c3]);
                  out.write(10);
                  out.write(encoding[c4]);
                  count = 1;
                  break;
               case 74:
                  out.write(encoding[i]);
                  out.write(encoding[c2]);
                  out.write(10);
                  out.write(encoding[c3]);
                  out.write(encoding[c4]);
                  count = 2;
                  break;
               case 75:
                  out.write(encoding[i]);
                  out.write(10);
                  out.write(encoding[c2]);
                  out.write(encoding[c3]);
                  out.write(encoding[c4]);
                  count = 3;
                  break;
               case 76:
                  out.write(10);
                  out.write(encoding[i]);
                  out.write(encoding[c2]);
                  out.write(encoding[c3]);
                  out.write(encoding[c4]);
                  count = 4;
                  break;
               default:
                  out.write(encoding[i]);
                  out.write(encoding[c2]);
                  out.write(encoding[c3]);
                  out.write(encoding[c4]);
                  count += 4;
               }
            }

            for(i = 0; i < 3; ++i) {
               buffer[i] = i < var10 - off?buffer[off + i]:0;
            }

            off = var10 - off;
         } else {
            off += var10;
         }
      }

      switch(off) {
      case 1:
         out.write(encoding[get1(buffer, 0)]);
         out.write(encoding[get2(buffer, 0)]);
         out.write(61);
         out.write(61);
         break;
      case 2:
         out.write(encoding[get1(buffer, 0)]);
         out.write(encoding[get2(buffer, 0)]);
         out.write(encoding[get3(buffer, 0)]);
         out.write(61);
      }

   }

}
